using AlgoSdk.Experimental.Abi;

namespace AlgoSdk
{
    public static partial class AtomicTxn
    {
        /// <summary>
        /// A Confirmed Atomic Transaction.
        /// </summary>
        public readonly struct Confirmed
        {
            readonly string[] txnIds;
            readonly MethodCallResult[] results;
            readonly ulong confirmedRound;

            /// <summary>
            /// The confirmed transaction ids.
            /// </summary>
            public string[] TxnIds => txnIds;

            /// <summary>
            /// Results from the ABI method calls.
            /// </summary>
            public MethodCallResult[] Results => results;

            /// <summary>
            /// The round this atomic transaction was confirmed.
            /// </summary>
            public ulong ConfirmedRound => confirmedRound;

            public Confirmed(string[] txnIds, MethodCallResult[] results, ulong confirmedRound)
            {
                this.txnIds = txnIds;
                this.results = results;
                this.confirmedRound = confirmedRound;
            }
        }
    }
}
